
#define VERSION "200502"
/*
  RA2 IR signal    l'etat 1 au repos
  TSOP  Pin 1=Gnd    Pin 2 = alim Vcc via filtre 82 ohms 100F  Pin 3 : signal (R pull up de 10K)
  1*  2*     3*    vu de face
  18 commandes  testes  sur telecommande ensemble Radio /CD/TUNER SONY  telecommande RM-SCU37
  SQA Analyser   1er bit=2.412mS  
  bit=0  => Zero: 508 S  + un: 718S
  bit=1  => Zero: 588 S  + un: 1210S

23/07/2012
  Modif traitement erreur separees sur COM
  affiche les etats d'erreurs
  Timer1 non utilise

21/07/2012
  Test UART Hardware on RA0 RA1 with interrupt mode
  Test with Timer0 interrup for blinking Led rouge    RA4
  RA3 MCLR for ICSP

Pickit2 OK avec  PIC12F1840, il faut choisir la famille 1,8V !!
*/
#define DIRECTORY "C:\\_MikroC\\_MesProjets_MikroC\\_12F1840_SONY_Telecommande_IR"
#define PROJECT   "12F1840_Sony_IR_decode_Uart_Hardw.mcppi"
#define COMPILATEUR "MikroC PRO for PIC V 7.60"
#define MCU "PIC12F1840  ehanced type"
#define SOURCE "_12F1840_Sony_IR_decode_Uart_Hardw"
#define TELECOMMANDE "Sony RM-SCU37"
#define FOSC_INTERNE "8x4 =>32 MHz"


#pragma ReentrancyCheck OFF

 /*
   CONFIG1   :$8007 : 0x0984
   CONFIG2   :$8008 : 0x3413
   
 http://www.hifi-remote.com/sony/Sony_cdcombo.htm
   
   pinout :   ac:Pinout_12F1840
   device ID =  01 1011 100
   Calibrations words 8009h & 800Ah
   hex file au format : INHX32   LSB puis MSB
   docu :
 */

  /* Hardware
  12F1840
  pin 1     VDD Alim +5V    ATTENTION !!!!!!!!!!!!!!
  pin 2     RA5  output2 -- R1K-- Led Blanche -- +5V
  pin 3     RA4  output1 -- R1K-- Led Rouge -- +5V
  pin 4     RA3/MCLR/VPP -- ICSP Reset
  pin 5     RA2  <---- IR signal TSOP
  pin 6     RA1  ICSP Clock  &  input RX ---- 1  DS275 7 ------ 2 TX RS232
  pin 7     RAO  ICSPDAT     &  output TX --- 3  DS275 5 ------ 3 RX RS232
  pin 8     VSS alim 0V
  */

#include "built_in.h"     // for  Hi  Lo ..etc
  
#define TAB 9
#define CLS 12
#define CR 13
#define LF 10

#define Led_Rouge LATA.F4      // RA4      led (tire au +5V via pull up)
#define Led_Blanche LATA.F5      // RA5




const code char mesg0[]=" Mikroc pro 7.60  02.05.2020\r\n";
const code char mesg1[]=" 12F1840 UART1  TSOP IR\r\n";
const code char mesg2[]=" Projet :"PROJECT"\r\n";
const code char mesg3[]=" Source :"SOURCE"_"VERSION".c\r\n";
const code char mesg4[]=" Telecommande :" TELECOMMANDE"\r\n";
const code char mesg5[]=" 18 commandes possibles\r\n";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5};

 // timer0
//unsigned char  NbCycles_T0 = 0;     //     255-0=255  prescaler=1/256 => 16.384 mS
 // timer1
//unsigned long  NbCycles_T1= 3035 ; //65535-62500=3035 @16Mhz et prescaler=8 => 125mS

 
unsigned short error;
volatile unsigned int CptErr;
volatile unsigned int  CptFE,CptOV;
volatile unsigned int Count1;
volatile  volatile unsigned int Count0;
volatile int Flag_Timer1;
volatile int Flag_Timer0;
volatile int Flag_Buffer;
volatile int Index;
volatile  unsigned char c1;
volatile int j;
unsigned int i,k;
unsigned M;
char buffer[32];
char *txt;
char Texte[64];
char CRam1[32];

// global variables
unsigned int counter; // store timer 1 value
volatile unsigned int Capture_bits; // assemble and store incoming bits
unsigned char Cpt_bits ;// count incoming bits
unsigned char current_state; // 1=idle 2=start 3=capture
volatile bit Code_IR_found; // flag set in Interrupt to show message ready
unsigned int command_id; // store for 7 bit command
unsigned int device_id; // store for 5 bit address


void strConstRamCpy(char *dest, const char *source);
void Print(char * texte);
void CRLF1(void);
void CPrint(const char *txt1);
void Tempo(unsigned long L);
void interrupt(void) ;
void Init_Timer0(void);
//void Init_Timer1(void);


void Interrupts() iv 0x0004 ics ICS_AUTO 
{
  if (PIR1.RCIF==1)
   {
   // traitement separe des erreurs de COM

    if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
     {
      c1=RCREG;           // efface drapeau OVERRUN
       RCSTA.CREN = 0 ;
       RCSTA.CREN = 1 ;
       CptOV++;
      }
    if(RCSTA.FERR==1 )
    {
     RCSTA.SPEN = 0 ;
     CptFE++;
     RCSTA.SPEN= 1 ;
     }
    c1 = RCREG;
   if ((c1==13)| (Index>31))
    {
    buffer[Index]=0;
    Flag_Buffer=1;
    PIE1.RCIE=0 ; // interdit IT Reception UART
    }
    else
    {
   buffer[Index]=c1;
   Index++;
    }
    PIR1.RCIF=0   ;
  }
   if ((INTE_bit==1) && (INTF_bit==1))
    { // RA2 external Interrupt
        switch(current_state)
        {
        case 1: //Idle,starting
            current_state = 2;
            INTEDG_bit = 1; // interrupt on rising edge
            break;
        case 2: // start_bit, found rising edge, check length for 2.4ms
            counter = TMR1L; // also loads TMR1 H
            counter=counter + (TMR1H * 256U); // combine timer 1 high and low
            if((counter > 2000) && (counter < 2800)){ // acceptable uS values for start
                Cpt_bits = 0; // start counting bits in
                Capture_bits = 0; // clear old value
                current_state = 3; // start receiving bits
            }
            else{ // fault signal, reset to idle
                current_state = 1;
                INTEDG_bit = 0; // interrupt on falling edge
            }
            break;
        case 3: //capture bit, start receiving data
            //check pulse length for "0" (0.6 mS space + 0.6 mS mark)
            // or "1" (0.6 mS space + 1.2 mS mark)
            counter = TMR1L; // also loads TMR1 H
            counter += (TMR1H * 256U); // combine timer 1 high and low
            Cpt_bits++;
            Capture_bits= Capture_bits >> 1; // make room for 0 bit

            if(counter > 1500){ // acceptable uS values for zero/one discrimination
                Capture_bits=Capture_bits  | 0x8000; // change 0 to 1
            }
            if (Cpt_bits == 12)
            { // complete 12 bits
                Code_IR_found = 1; // indicate that a message is ready
                Capture_bits >>= 4; // shift 12 bits into lower bits of word
                current_state = 1; // ready to start receiving again
               INTE_bit=0;
           }
            break;
        default:
         current_state = 1;
          break;
        }
        TMR1IF_bit=0;
        TMR1H = 0x00; // reset timer
        TMR1L = 0x00;
       // INTEDG_bit = 0;
        INTF_bit = 0; // clear Interrupt flag
    }
    // handle Timer 1 interrupt
    if (TMR1IF_bit) // Timer1 overflow
    {
        current_state = 1; // timer has overflowed - so return to idle
        TMR1IF_bit = 0; // clear Interrupt flag
    }
}


void Print(char * texte)
{
while (* texte)
 {
  UART_Write(* texte++);
 }
}

void CPrint(const char *txt1)
 {
   while (*txt1)
      UART1_Write(*txt1++);
      Delay_us(5);
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source) {
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART_Write(CR);
 UART_Write(LF);
}

 void Tempo(unsigned long L)
 {
 while (L>0) L--;
 }




void main()
{
  // voir page 61
  // 0=4xPLL ON 1111=IOFS=8x4=32Mhz
  OSCCON=0b01110000;   // 8MHZ
  OSCCON.SPLLEN=1;// PLL=1
  ANSELA=0;             // no analog
  LATA=0;
   WPUA=0b00000011;      // weak pull up on RX & TX
  TRISA.B2=1;
  CM1CON0=0;       // disable comparators
  CM1CON1=0;
  CCP1CON=0;       // indispensable pour UART sur RA0
  

  APFCON=0;
  APFCON.P1BSEL=1;    // pour deconnecter de RA0 mais connecte sur RA4 ???!!
  APFCON.RXDTSEL=0;   // RX sur RA1
  APFCON.TXCKSEL=0;   // TX sur RA0
    // RA0 as output for TX , RA1 as input for RX , RA2 as input
    // RA4 et RA5 en sorties  pour leds
  TRISA=0b0000110;
   Led_Rouge=1;  //RA4
   
   for (i=0;i<10;i++)
   {
     Led_Rouge=!Led_Rouge;  //RA4
    Delay_ms(250);
   
   }

  FVRCON.FVREN=0;       // disable fixed voltage reference     (voir page 124)
  FVRCON.TSEN=0;        // temperature enable=0;

    INTEDG_bit = 0; // interrupt on falling edge
   
    T1CON = 0x31; // Timer 1 on, FOSC/4, 2:1, internal osc gives mS count
    TMR1H = 0x00; // reset timer
    TMR1L = 0x00;
    INTCON = 0xC0; // Eneble peripheral and global interrupts
    TMR1IE_bit = 1;
    INTE_bit = 1; // Enable RA2 Interrupt

    current_state = 1; // Idle
    counter = 0;
    Code_IR_found = 0;
    INTEDG_bit =0; // interrupt on falling edge

  
   txt=&Texte[0];
   UART1_Init(19200);
   Tempo(100000);
  // RA0 as  as output for TX , RA1  as input for RX
  // RA4 et RA5 en sorties  pour leds
   TRISA=0b0000110;

   Flag_Buffer=0;
   UART_Write(CLS);
   Tempo(200000);       // Wait for cleaning
   Flag_Buffer=0;
   Index=0;
    txt=&Texte[0];
  
   // ======== test Zone =====================
  //while (1)
  // {
  // if (UART1_Data_Ready() == 1)   // if data is received
  //  {
  //   UART1_Read_Text(txt, "OK", 255) ; // reads text until 'OK' is found
  //   UART1_Write_Text(txt)   ;// sends back text
  //   c1 = RCREG;
  //  }
  // }

    // ======== test Zone =====================
   
   
//  strConstRamCpy(txt, Messages[0] );  Print(txt);
//   strConstRamCpy(txt,  Messages[1] ); Print(txt);

  CPrint(" Presentation :\r\n");
  for (i=0;i<5;i++)
  {
    CPrint(Messages[i]);
  }
  
   txt=&Texte[0];
   CRLF1();
   Count0=0;
   CptErr=0;
   CptOV=0;
   CptFE=0;
   c1=0;
    //

  RCSTA=0;
  RCSTA.CREN=1;  //enable receiver
  RCSTA.SPEN=1;  // serial port Pins Enable
  RCSTA.SREN=1;  // single bit receive
  c1 = RCREG;   // RAZ errors

   CPrint (" IT UART RA0=Tx RA1=Rx & IT RA2 \r\n");
   CPrint (" Attente action sur tlcommande SONY ...\n\r");
   CRLF1();

     PIE1.TMR1IE=0;
     INTCON.PEIE=1;  // autorise IT des peripherique voir fig  8.1 p 77
     INTCON.GIE=1;   // Enable all interrupts (timer1 & UART)

  j=0;
  k=0;
  CptOV=0;
  CptFE=0;
  CptErr=0;
  
 do
  {

   if(Code_IR_found==1)
   {
           Led_Rouge=0;  // allume led
           txt=&Texte[0];
            CRam1[0]=0;
           j++;
           WordToStr(j,txt);
           UART_Write_Text(txt);   UART_Write(TAB);
           CPrint(" Code : ");
           WordToHex(  Capture_bits  ,CRam1);
           Print(CRam1);  UART_Write(TAB);
           CPrint(" Device ID = ");
           device_id= Capture_bits >> 7; ;
           WordToStr(  device_id  ,CRam1);
           Print(CRam1);  UART_Write(TAB);
           CPrint(" Code Touche = ");
           command_id = Capture_bits & 0x003F;
           WordToStr(  command_id  ,CRam1);
           Print(CRam1);  UART_Write(TAB);
           
           // traitement decodage Commande
           if ( (device_id == 16) || (device_id == 26))
            { // Sony Audio RM-SCU37
                switch(command_id)
                {
                    case 0x15: // "1" button
                        CPrint( " Clear ");    CRLF1();
                        break;
                    case 18:
                         CPrint( " Vol+ ");      CRLF1();
                        break;
                    case 19:
                          CPrint( " Vol- ");     CRLF1();
                        break;
                    case 0x30:
                          CPrint( " <<< - Arr.Rapide ") ;  CRLF1();
                        break;
                     case 0x30:
                          CPrint( " <<< - ") ;  CRLF1();
                        break;
                     case 0x30:
                          CPrint (" <<< - Arr.Rapide. ");   CRLF1();
                        break;
                      case 0x31:
                          CPrint (" + >>> Avant.Rapide");   CRLF1();
                        break;
                      case 0x32:
                          CPrint( " > Avance ") ;  CRLF1();
                        break;
                      case 0x33:
                          CPrint (" << - Arr.lent") ;  CRLF1();
                        break;
                      case 0x34:
                          CPrint ("+ >> Avant lent ") ;  CRLF1();
                        break;
                     case 0x39:
                          CPrint (" ||  Pause ");   CRLF1();
                        break;
                        
                    case 0x1A:
                          CPrint (" USB ");   CRLF1();
                        break;
                    case 0x25:
                          CPrint (" CD ");   CRLF1();
                        break;
                     case 0x0F:
                          CPrint (" TUNER ");   CRLF1();
                        break;
                     case 0x09:
                          CPrint (" Functions ");   CRLF1();
                        break;
                    case 0x4B:
                          CPrint (" Display ");   CRLF1();
                        break;
                    case 0x40:
                          CPrint (" Tuning Mode ");   CRLF1();
                        break;
                    case 0x4B:
                          CPrint (" Display ");   CRLF1();
                        break;
                    case 0x37:
                          CPrint (" SET ");   CRLF1();
                        break;

                     default  :
                         CPrint (" ?? "); CRLF1();
                         break;
                }
            }

            Delay_1sec();
            current_state = 1; // Idle - kill repeat message in progress
            counter = 0;
            Capture_bits=0;
            Code_IR_found = 0;
            Led_Rouge=1;  // eteint led (tire au +5V via pull up)
            INTEDG_bit =0; // interrupt on falling edge
            INTF_bit=0;
            INTE_bit=1;
      }

//  Wait to flag buffer full or string ended by car=CR=13)0x0D
//  Uart with interrupt
   if ( Flag_Buffer==1)
    {
     UART_Write_Text(buffer);
     Flag_Buffer=0;
     c1=0;
     Index=0;
     WordToStr(Index, txt);  UART_Write_Text(txt);  UART_Write(TAB);
    // WordToStr(CptErr, txt) ; UART_Write_Text(txt);  UART_Write(TAB);
     WordToStr(CptOV, txt) ; UART_Write_Text(txt);  UART_Write(TAB);
     WordToStr(CptFE, txt) ; UART_Write_Text(txt);  UART_Write(TAB);
     CptOV=0;
     CptFE=0;
     CptErr=0;
     PIE1.RCIE=1 ; // re-autorise IT Reception UART
   }

  }  while (1);


 }
 /* Presentation :
 Mikroc pro 7.60  02.05.2020
 12F1840 UART1  TSOP IR
 Projet :12F1840_Sony_IR_decode_Uart_Hardw.mcppi
 Source :_12F1840_Sony_IR_decode_Uart_Hardw_200502.c
 Telecommande :Sony RM-SCU37

 IT UART RA0=Tx RA1=Rx & IT RA2
 Attente action sur tlcommande SONY ...


    1         Code : 0812         Device ID =    16         Code Touche =    18         Vol+
    2         Code : 0813         Device ID =    16         Code Touche =    19         Vol-
    3         Code : 0D32         Device ID =    26         Code Touche =    50         > Avance
    4         Code : 0D39         Device ID =    26         Code Touche =    57         ||  Pause
    5         Code : 0D30         Device ID =    26         Code Touche =    48         <<< - Arr.Rapide
    6         Code : 0D31         Device ID =    26         Code Touche =    49         + >>> Avant.Rapide
    7         Code : 081A         Device ID =    16         Code Touche =    26         USB
    8         Code : 0825         Device ID =    16         Code Touche =    37         CD
    9         Code : 080F         Device ID =    16         Code Touche =    15         TUNER
   10         Code : 084B         Device ID =    16         Code Touche =    11         ??
   11         Code : 0865         Device ID =    16         Code Touche =    37         CD
   12         Code : 0D0F         Device ID =    26         Code Touche =    15         TUNER
   13         Code : 0863         Device ID =    16         Code Touche =    35         ??
   14         Code : 0D2E         Device ID =    26         Code Touche =    46         ??
   15         Code : 0D2F         Device ID =    26         Code Touche =    47         ??
   16         Code : 0D2E         Device ID =    26         Code Touche =    46         ??



    0 1144 Used RAM (bytes): 196 (82%)  Free RAM (bytes): 44 (18%)
    0 1144 Used ROM (program words): 2136 (52%)  Free ROM (program words): 1960 (48%)
*/